
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef int (cmp_t)(void const *a, void const *b);

static void insertsort(void* vals, size_t n, size_t sz, cmp_t *cmp)
{
#define V(k) (((char *) vals) + ((k) * sz))
    for (unsigned i = 1; i < n; i++) {
        void *x = V(i);
        for (unsigned j = i; j > 0 && cmp(V(j), x) > 0; j--) {
            memcpy(V(j), V(j - 1), sz);
        }
    }
#undef V
}

static int int_cmp(void const *a, void const *b)
{
    int const *p = a;
    int const *q = b;

    return (*q < *p) - (*p < *q);
}

static void insertsort_int(int *vals, size_t n)
{
    insertsort(vals, n, sizeof(int), int_cmp);
}

int main(int argc, char const **argv)
{
    int n = 1000;

    if (argc > 1)
        n = atoi(argv[1]);

    int *arr = malloc(n * sizeof(arr[0]));
    for (int i = 0; i < n; i++)
        arr[i] = rand();
    insertsort_int(arr, n);

    return arr[n - 1];
}
